'**************************************************************************************************************
' SetWOL.vbs
'
' Copyright (c) 2008 Fujitsu Siemens Computers
'
' v 1.1
'**************************************************************************************************************
'Set WOL for Intel 82566MM Gigabit Network Controller (onboard) on Esprimo Q5020
'**************************************************************************************************************

Dim Counter, DeviceFound, PMEvalue, PnPCapabilitiesValue, ComponentIDValue
Counter = 0
DeviceFound = 0

'PMEvalue = 2			' OS controlled
PMEvalue = 1			' Enabled
'PMEvalue = 0			' Disabled

PnPCapabilitiesValue = 32	' Allow the computer to turn off... & Only Allow  management stations... (=0x20)
'PnPCapabilitiesValue = 288	'All PnP functions on (=0x120)
'PnPCapabilitiesValue = 56	'All PnP functions off (=0x38)

ComponentIDValue = "pci\ven_8086&dev_1049"



Do 
	'WScript.Echo "Counter=" & Counter
	If (Counter < 10) Then						' Link registry path
		EnablePME = ("HKLM\SYSTEM\CurrentControlSet\Control\Class\{4D36E972-E325-11CE-BFC1-08002BE10318}\000" & Counter & "\EnablePME")
		ComponentID = ("HKLM\SYSTEM\CurrentControlSet\Control\Class\{4D36E972-E325-11CE-BFC1-08002BE10318}\000" & Counter & "\ComponentID")
		PnPCapabilities = ("HKLM\SYSTEM\CurrentControlSet\Control\Class\{4D36E972-E325-11CE-BFC1-08002BE10318}\000" & Counter & "\PnPCapabilities")	
	Else
		EnablePME = ("HKLM\SYSTEM\CurrentControlSet\Control\Class\{4D36E972-E325-11CE-BFC1-08002BE10318}\00" & Counter & "\EnablePME")
		ComponentID = ("HKLM\SYSTEM\CurrentControlSet\Control\Class\{4D36E972-E325-11CE-BFC1-08002BE10318}\00" & Counter & "\ComponentID")
		PnPCapabilities = ("HKLM\SYSTEM\CurrentControlSet\Control\Class\{4D36E972-E325-11CE-BFC1-08002BE10318}\000" & Counter & "\PnPCapabilities")
	End If

	'WScript.Echo "EnablePME=" & EnablePME
	'WScript.Echo "ComponentID=" & ComponentID
	If RegExists (EnablePME) Then					' Check if network device has a EnablePME key
		If RegExists (ComponentID) Then				' Check if network device has a ComponentID key
			Set wso = CreateObject("Wscript.Shell")
			value = wso.RegRead("HKLM\SYSTEM\CurrentControlSet\Control\Class\{4D36E972-E325-11CE-BFC1-08002BE10318}\000" & Counter & "\ComponentID")
			'WScript.Echo "Value=" & value
				If (value = ComponentIDValue) Then	' Check if PCI-ID is correct
    					'WScript.Echo "Key was found"
					wso.RegWrite EnablePME, PMEvalue, "REG_SZ"				' Set EnablePME value
					wso.RegWrite PnPCapabilities, PnPCapabilitiesValue, "REG_DWORD"		' Set PnPCapabilities value
					DeviceFound = DeviceFound + 1
				End If
		Else 'WScript.Echo "Wrong device"
		End If
				
	Else
     		'WScript.Echo "EnablePME key not found"
	End If 
	Counter = Counter +1
Loop While Counter < 100						' Repeat the test for up to 100 network devices
WScript.Echo "Intel 82566MM Gigabit Network Controller was found " & DeviceFound & " time(s) in the registry and WOL values were set." & vbCr & vbLf &_
	    vbCr & vbLf & "                                    Please reboot the system."



' Function to check if a registry key exists. Compare 
Function RegExists(regPath)
	Dim wso, value, errString
	On Error Resume Next						' deactivate runtime errors
	RegExists = False						' set default=False
	Set wso = CreateObject("Wscript.Shell")
	If (Right(regPath, 1) <> "\") Then				' check for Reg Value
		value = wso.RegRead(regPath)				' try to read
		If (Err.Number=0) Then RegExists = True
	Else								' check for Reg Key
		value = wso.RegRead("HKLM\Dummy\")			' get the description text
		errString = Replace(Err.Description, """HKLM\Dummy\"".", "")
		value = wso.RegRead(regPath)				' try to read
		If (Err.Number=0) Then					' success? 
			RegExists = True
		Else							' or same description ?
			If Replace(Err.Description, """" & regPath &""".", "") <> errString Then 
				RegExists = True
			End If
		End If
	End If

	Set wso = Nothing
	On Error Goto 0
End Function
